# List Pull requests

> Source: https://truto.one/docs/api-reference/unified-ci-cd-api/pullrequests/list/

`GET /unified/ci-cd/pull-requests`

Resource: **PullRequests** · API: **Unified CI/CD API**

## Supported integrations

Bitbucket, Buddy, Gerrit, GitHub, GitLab

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_key_by`** _(string)_
  By default the `result` attribute is an array of objects. This parameter allows you to specify a field in each `result` objects to use as key, which transforms the `result` array into an object with the array items keyed by the field. This is useful for when you want to use the result as a lookup table.
- **`truto_ignore_limit`** _(boolean)_
  Ignores the `limit` query parameter.
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.
- **`workspace_id`** _(unknown)_
- **`repo`** _(unknown)_
- **`workspace`** _(unknown)_
- **`filter_Query`** _(object)_
  Provide either raw or tokens; tokens use operator_value with the first underscore converted to a colon, and tokens containing :, spaces, quotes, or parentheses are used as is.
- **`owner`** _(string)_
  The slug of the owner on Github.
- **`repo_id`** _(string)_
- **`title`** _(string)_
  The title of the pull request
- **`status`** _(string)_
  Either open, closed, or all to filter by state. Default is all.
  Allowed: `all`, `closed`, `locked`, `merged`, `open`
- **`sort_by`** _(object)_
- **`created_at`** _(string)_
  The date and time when the pull request was created
- **`updated_at`** _(string)_
  The date and time when the pull request was last updated

## Response body

- **`result`** _(array<object>)_
  List of Pull requests
  - **`id`** _(string, required)_
    The unique identifier for the pull request
  - **`title`** _(string)_
    The title of the pull request
  - **`number`** _(integer)_
    The number of the pull request
  - **`description`** _(object)_
    The description of the pull request
    - **`content`** _(string)_
      The content of the body
    - **`format`** _(string)_
      The format of the body
      Allowed: `markdown`, `html`, `plaintext`
  - **`status`** _(string)_
    The status of the pull request
    Allowed: `open`, `closed`, `merged`, `locked`
  - **`base_branch`** _(object)_
    The base branch of the pull request
    - **`id`** _(string)_
      The unique identifier for the base branch
    - **`name`** _(string)_
      The name of the base branch
    - **`last_commit`** _(string)_
      The last commit of the base branch
  - **`head_branch`** _(object)_
    The head branch of the pull request
    - **`id`** _(string)_
      The unique identifier for the head branch
    - **`name`** _(string)_
      The name of the head branch
    - **`last_commit`** _(string)_
      The last commit of the head branch
  - **`author`** _(object)_
    The author of the pull request
    - **`id`** _(string)_
      The unique identifier for the author
    - **`username`** _(string)_
      The username of the author
    - **`type`** _(string)_
      The type of the author
      Allowed: `user`, `bot`
  - **`closed_at`** _(string)_
    The date and time when the pull request was closed
  - **`merged_at`** _(string)_
    The date and time when the pull request was merged
  - **`created_at`** _(string)_
    The date and time when the pull request was created
  - **`updated_at`** _(string)_
    The date and time when the pull request was last updated
  - **`remote_data`** _(object)_
    Raw data returned from the remote API call.
- **`next_cursor`** _(string)_
  The cursor to use for the next page of results. Pass this value as `next_cursor` in the query parameter in the next request to get the next page of results.

## Code examples

### curl

```bash
curl -X GET 'https://api.truto.one/unified/ci-cd/pull-requests?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const response = await fetch(`https://api.truto.one/unified/ci-cd/pull-requests?integrated_account_id=${integratedAccountId}`, {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ci-cd/pull-requests"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}

response = requests.get(url, headers=headers, params=params)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.list(
  'ci-cd',
  'pullrequests',
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    async for item in truto_api.unified_api.list(
        "ci-cd",
        "pullrequests",
        {"integrated_account_id": "<integrated_account_id>"}
    ):
        print(item)

asyncio.run(main())
```
